#include <bits/stdc++.h>
using namespace std;

#define TASK "graph"
typedef long long ll;

int n, m;
vector <vector <int> > g;
vector <int> dp;
vector <int> in;
int timer = 0;
vector <set<int> > b;
int dfs(int v, int p = -1) {
    dp[v] = in[v] = timer++;
    for (int eid = 0; eid < (int)g[v].size(); eid++) {
        int to = g[v][eid];
        if (to == p) continue;
        if (in[to] != -1) dp[v] = min(dp[v], in[to]);
        else {
            dp[v] = min(dp[v], dfs(to, v));
            if (dp[to] > in[v]) {
                b[v].insert(to);
                b[to].insert(v);
            }
        }
    }
    return dp[v];
}

int dfs2(int v) {
    in[v] = true;
    int ans = 0;
    for (set<int>::iterator it = b[v].begin();
         it != b[v].end(); it++) {
        int to = *it;
        if (in[to] == -1) ans += dfs2(to);
    }
    return ans + 1;
}

int main() {
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    b.resize(n);
    in.assign(n, -1);
    dp.resize(n);

    for (int i = 0; i < n; i++) {
        if (in[i] == -1) {
            dfs(i);
        }
    }

    ll ans = 0;
    in.assign(n, -1);
    for (int i = 0; i < n; i++) {
        if (in[i] == -1) {
            int x = dfs2(i);
            ans += 1LL * x * (x - 1) / 2 - x + 1;
        }
    }

    cout << ans << endl;
}
