#include<iostream>
#include<cstdio>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "netree"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;
const int INF = 1000000000;


int mtr[500][500], new_mtr[500][500], used[500], p[500], d[500], need_d[500], mtr1[500][500];
int n, s = 1, c = 0;
int iterate_dijkstra(int a, int b) {
	for (int i = 1; i <= n; ++i) 
    	d[i] = INF, used[i] = 0, p[i] = 0;
    d[s] = 0;
    for (int it = 0; it < n; ++it) {
    	int v = -1;
    	for (int i = 1; i <= n; ++i)
    		if (!used[i] && (v == -1 || d[i] < d[v]))
    			v = i;
    	used[v] = 1;
    	for (int i = 1; i <= n; ++i) {
    		if (((a != v || b != i) && (b != v || a != i)) && d[v] + mtr[v][i] < d[i]) {
    			d[i] = d[v] + mtr[v][i];
    		}
    	}
    }
    
    int ans = 0;
    for (int i = 1; i <= n; ++i)
    	ans += d[i] != need_d[i];
    return ans;
}


int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen("stupid_" NAME ".out", "w", stdout); 
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
    	for (int j = 1; j <= n; ++j) {
    		scanf("%d", &mtr[i][j]);
    	}
    }
    for (int i = 1; i <= n; ++i) 
    	need_d[i] = INF;
    need_d[s] = 0;
    for (int it = 0; it < n; ++it) {
    	int v = -1;
    	for (int i = 1; i <= n; ++i)
    		if (!used[i] && (v == -1 || need_d[i] < need_d[v]))
    			v = i;
    	used[v] = 1;
    	for (int i = 1; i <= n; ++i)
    		need_d[i] = min(need_d[i], need_d[v] + mtr[v][i]);
    }

    int ans = 0;

    for (int i = 1; i <= n; ++i) {
    	for (int j = 1; j <= n; ++j) {
    		ans = max(ans, iterate_dijkstra(i, j));		
    	}
    }
    printf("%d", ans);        
    return 0;
}







