#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

bool cmp(int a, int b)
{
    long long q = 10, w = 10;
    while (q <= a)
        q *= 10;
    while (w <= b)
        w *= 10;
    long long x = (long long)a * w + b;
    long long y = (long long)b * q + a;
    return x > y;
}

vector<int> merge_sort(vector<int> v)
{
    if (v.size() == 1)
        return v;
    vector<int>::iterator it = v.begin() + (v.size() / 2);
    vector<int> left(v.begin(), it);
    vector<int> right(it, v.end());
    left = merge_sort(left);
    right = merge_sort(right);
    vector<int> ans;
    int i = 0, j = 0;
    while (i < (int)left.size() && j < (int)right.size())
    {
        if (cmp(left[i], right[j]))
            ans.push_back(left[i++]);
        else
            ans.push_back(right[j++]);
    }
    while (i < (int)left.size())
        ans.push_back(left[i++]);
    while (j < (int)right.size())
        ans.push_back(right[j++]);
    return ans;
}


int main()
{
    int n;
    freopen("maxnumber.in", "r", stdin);
    freopen("maxnumber.out", "w", stdout);
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    a = merge_sort(a);
    for (int i = 0; i < n; i++)
        cout << a[i] << ' ';
    return 0;
}